import haxegon.*;

class Main {

	var cx:Int=5;
	var cy:Int=5;
	var tw:Int=10;
	var th:Int=10;
	var gw:Int=9;
	var gh:Int=10;
	var ox:Int=46;
	var oy:Int=4;

	var contents:Array<Array<Int>>;
	var hbars:Array<Array<Int>>;
	var vbars:Array<Array<Int>>;

	// new() is a special function that is called on startup.
	function new() {
		init();
	}
	
	function init (){
		counter=10;
		cx=5;
		cy=5;
		Gfx.loadimage("background");
			Gfx.loadimage("cursor");
			Gfx.loadimage("tile0");
			Gfx.loadimage("tile1");
			Gfx.loadimage("tile2");
			Gfx.loadimage("tile3");
			Gfx.loadimage("tile4");
			Gfx.loadimage("tile5");
			Gfx.loadimage("tile6");
			Gfx.loadimage("tile7");
			Gfx.loadimage("tile8");
			Gfx.loadimage("tile9");

			Gfx.resizescreen(192,120);		
			Gfx.createimage("buffer",192,120);
			contents = new Array<Array<Int>>();
			for (i in 0...gw){
				var r:Array<Int> = new Array<Int>();
				for (j in 0...gh){
	 				r.push(Random.int(0,3));
				}
				contents.push(r);
			}
			var anytriples = true;
			while(anytriples){
				anytriples=false;
				for (i in 0...gw){
					for (j in 0...(gh-2)){
						if (contents[i][j]==contents[i][j+1] && contents[i][j]==contents[i][j+2]){
							contents[i][j+1]=((contents[i][j+1]+1)%4);
							anytriples=true;
						}
					}
				}
				for (i in 0...gw-2){
					for (j in 0...(gh)){
						if (contents[i][j]==contents[i+1][j] && contents[i][j]==contents[i+2][j]){
							contents[i+1][j]=((contents[i+1][j]+1)%4);
							anytriples=true;
						}
					}
				}
			}
			drawScreen();
	}
  var cols = [0xebe840,0x0091cb,0xfcaf17,0xee4594,0x34ae00,0,0,0,0,0];
  function drawScreen(){
  	Gfx.drawtoimage("buffer");
  	Gfx.drawimage(0,0,"background");
	for (i in 0...gw){
		for (j in 0...gh){
			var t = contents[i][j];
			if (t<0){
				continue;
			}
			var n = "tile"+t;
			Gfx.drawimage(ox+1+i*(tw+1),oy+1+j*(th+1),n);
			if (i<gw-1){
				var t2 = contents[i+1][j];
				if ((t%5)==(t2%5)){
					var m = t>t2?t:t2;
					Gfx.fillbox(ox+1+i*(tw+1)+tw,oy+1+j*(th+1),1,th,cols[m]);
				}	
			}
			if (j<gh-1){
				var t2 = contents[i][j+1];
				if ((t%5)==(t2%5)){				
					var m = t>t2?t:t2;
					Gfx.fillbox(ox+1+i*(tw+1),oy+1+j*(th+1)+tw,tw,1,cols[m]);
				}	
			}
		}
	}	
  	Gfx.drawtoscreen();
  }

  function doSwap(){
  	var t = contents[cx][cy];
  	contents[cx][cy]=contents[cx+1][cy];
  	contents[cx+1][cy]=t;
  	if (detectMatch3()){
		movePhase=1;
		moveTimer=0;
  	} else {
  		counter--;
  	}
  	drawScreen();
  }

  function detectMatch3(){
	var anytriples = false;

	for (i in 0...gw){
		for (j in 0...(gh-2)){
			var t = contents[i][j];
			if (t<0){ 
				continue;
			}
			t=t%5;
				
			if (t==(contents[i][j+1]%5) && t==(contents[i][j+2]%5)){
				anytriples=true;
				for (k in j...gh){
					var ck  = contents[i][k];
					if (ck>=0 && (ck%5==t)){
						contents[i][k]=t+10;
					} else {
						break;
					}
				}
			}
		}
	}
	
	
	for (i in 0...(gw-2)){
		for (j in 0...(gh)){
			var t = contents[i][j];
			if (t<0){ 
				continue;
			}
			t=t%5;
				
			if (t==(contents[i+1][j]%5) && t==(contents[i+2][j]%5)){
				anytriples=true;
				for (k in i...gw){
					var ck  = contents[k][j];
					if (ck>=0 && (ck%5==t)){
						contents[k][j]=-1;
					} else {
						break;
					}
				}
			}
		}
	}

	for (i in 0...(gw)){
		for (j in 0...(gh)){
			if (contents[i][j]>=10){
				contents[i][j]=-1;
			}
		}
	}
	return anytriples;
  }

  function tryDrop():Bool{
  	var anyDropped = false;
  	for (i in 0...gw){
  		for (j in 1...(gh)){
  			var y = gh-j;
  			if (contents[i][y]==-1&&contents[i][y-1]>=0){
  				anyDropped = true;
  				contents[i][y]=contents[i][y-1];
  				contents[i][y-1]=-1;
  			}
  		}
  	}
  	for (i in 0...gw){
  		if (contents[i][0]==-1){
			contents[i][0]=5+Random.int(0,3);
			anyDropped=true;
		}
  	}
  	return anyDropped;
  }

  var movePhase = 0;
  function anyHoles(){
	for (i in 0...(gw)){
		for (j in 0...(gh)){
			if (contents[i][j]==-1){
				return true;
			}
		}
	}
	return false;
  }

  function allBlack(){
	for (i in 0...gw){
		for (j in 0...gh){
			if (contents[i][j]<=4){
				return false;
			}
		}
	}
	return true;
  }

  var title:Bool=true;
  var moveTimer = 0;
  function update() {
  	if (title){
  		Text.display(Text.CENTER,5,"anesthesia");
  		Text.display(Text.CENTER,5+20,"press x to start");
  		Text.display(Text.CENTER,5+40,"arrow keys to move");
  		Text.display(Text.CENTER,5+60,"r to restart");
  		if (Input.justpressed(Key.X)){
  			title=false;
  		}
  		return;
  	}
	if (movePhase==2){
		Gfx.fillbox(0,0,Gfx.screenwidth,Gfx.screenheight,0x000000);
		Text.display(Text.CENTER,Text.CENTER,"the end",0xffffff);
		return;
	}
  			if (Input.delaypressed(Key.UP,5)){
			if(cy>0){
				cy--;
			}
		}
		if (Input.delaypressed(Key.DOWN,5)){
			if (cy<gh-1){
				cy++;
			}
		}
		if (Input.delaypressed(Key.LEFT,5)){
			if(cx>0){
				cx--;
			}
			
		}
		if (Input.delaypressed(Key.RIGHT,5)){
			if (cx<gw-2){
				cx++;
			}		
		}

  	if (movePhase ==1  ){  		
  		moveTimer++;
  		if (moveTimer == 5){
  			moveTimer = 0;
			if (tryDrop()){

			} else if (detectMatch3()){		

			} else {	
  				movePhase=0;	  				
				moveTimer=0;
				if (allBlack()){
					movePhase=2;
				}
			}
  			drawScreen();
  		}
  	} else {
	  	moveTimer = 0;


		if (Input.justpressed(Key.X)&&counter>0){
			doSwap();	
		}


		if (Input.justpressed(Key.R)){
			init();
		}
	}

  	Gfx.drawimage(0,0,"buffer");
  	Gfx.drawimage(ox+cx*(tw+1),oy+cy*(th+1),"cursor");
	Text.display(0,0,""+counter,0xffffff);
  }
  var counter:Int=1000;
}